# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ApiCloudaccountsvcfBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'sddc_manager_id': 'str',
        'workload_domain_id': 'str',
        'workload_domain_name': 'str',
        'vcenter_host_name': 'str',
        'vcenter_username': 'str',
        'vcenter_password': 'str',
        'create_default_zones': 'bool',
        'nsx_host_name': 'str',
        'nsx_username': 'str',
        'nsx_password': 'str',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'vcenter_certificate': 'str',
        'nsx_certificate': 'str',
        'accept_self_signed_certificate': 'bool',
        'dc_id': 'str',
        'regions': 'list[IaasapicloudaccountsvsphereRegions]',
        'certificate_info': 'IaasapiintegrationsCertificateInfo'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'sddc_manager_id': 'sddcManagerId',
        'workload_domain_id': 'workloadDomainId',
        'workload_domain_name': 'workloadDomainName',
        'vcenter_host_name': 'vcenterHostName',
        'vcenter_username': 'vcenterUsername',
        'vcenter_password': 'vcenterPassword',
        'create_default_zones': 'createDefaultZones',
        'nsx_host_name': 'nsxHostName',
        'nsx_username': 'nsxUsername',
        'nsx_password': 'nsxPassword',
        'tags': 'tags',
        'vcenter_certificate': 'vcenterCertificate',
        'nsx_certificate': 'nsxCertificate',
        'accept_self_signed_certificate': 'acceptSelfSignedCertificate',
        'dc_id': 'dcId',
        'regions': 'regions',
        'certificate_info': 'certificateInfo'
    }

    def __init__(self, name=None, description=None, sddc_manager_id=None, workload_domain_id=None, workload_domain_name=None, vcenter_host_name=None, vcenter_username=None, vcenter_password=None, create_default_zones=None, nsx_host_name=None, nsx_username=None, nsx_password=None, tags=None, vcenter_certificate=None, nsx_certificate=None, accept_self_signed_certificate=None, dc_id=None, regions=None, certificate_info=None):  # noqa: E501
        """ApiCloudaccountsvcfBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._sddc_manager_id = None
        self._workload_domain_id = None
        self._workload_domain_name = None
        self._vcenter_host_name = None
        self._vcenter_username = None
        self._vcenter_password = None
        self._create_default_zones = None
        self._nsx_host_name = None
        self._nsx_username = None
        self._nsx_password = None
        self._tags = None
        self._vcenter_certificate = None
        self._nsx_certificate = None
        self._accept_self_signed_certificate = None
        self._dc_id = None
        self._regions = None
        self._certificate_info = None
        self.discriminator = None
        self.name = name
        if description is not None:
            self.description = description
        if sddc_manager_id is not None:
            self.sddc_manager_id = sddc_manager_id
        self.workload_domain_id = workload_domain_id
        self.workload_domain_name = workload_domain_name
        self.vcenter_host_name = vcenter_host_name
        self.vcenter_username = vcenter_username
        self.vcenter_password = vcenter_password
        if create_default_zones is not None:
            self.create_default_zones = create_default_zones
        self.nsx_host_name = nsx_host_name
        self.nsx_username = nsx_username
        self.nsx_password = nsx_password
        if tags is not None:
            self.tags = tags
        if vcenter_certificate is not None:
            self.vcenter_certificate = vcenter_certificate
        if nsx_certificate is not None:
            self.nsx_certificate = nsx_certificate
        if accept_self_signed_certificate is not None:
            self.accept_self_signed_certificate = accept_self_signed_certificate
        if dc_id is not None:
            self.dc_id = dc_id
        self.regions = regions
        if certificate_info is not None:
            self.certificate_info = certificate_info

    @property
    def name(self):
        """Gets the name of this ApiCloudaccountsvcfBody.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ApiCloudaccountsvcfBody.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this ApiCloudaccountsvcfBody.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ApiCloudaccountsvcfBody.

        A human-friendly description.  # noqa: E501

        :param description: The description of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def sddc_manager_id(self):
        """Gets the sddc_manager_id of this ApiCloudaccountsvcfBody.  # noqa: E501

        SDDC manager integration id  # noqa: E501

        :return: The sddc_manager_id of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._sddc_manager_id

    @sddc_manager_id.setter
    def sddc_manager_id(self, sddc_manager_id):
        """Sets the sddc_manager_id of this ApiCloudaccountsvcfBody.

        SDDC manager integration id  # noqa: E501

        :param sddc_manager_id: The sddc_manager_id of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """

        self._sddc_manager_id = sddc_manager_id

    @property
    def workload_domain_id(self):
        """Gets the workload_domain_id of this ApiCloudaccountsvcfBody.  # noqa: E501

        Id of the workload domain to add as VCF cloud account.  # noqa: E501

        :return: The workload_domain_id of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._workload_domain_id

    @workload_domain_id.setter
    def workload_domain_id(self, workload_domain_id):
        """Sets the workload_domain_id of this ApiCloudaccountsvcfBody.

        Id of the workload domain to add as VCF cloud account.  # noqa: E501

        :param workload_domain_id: The workload_domain_id of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if workload_domain_id is None:
            raise ValueError("Invalid value for `workload_domain_id`, must not be `None`")  # noqa: E501

        self._workload_domain_id = workload_domain_id

    @property
    def workload_domain_name(self):
        """Gets the workload_domain_name of this ApiCloudaccountsvcfBody.  # noqa: E501

        Name of the workload domain to add as VCF cloud account.  # noqa: E501

        :return: The workload_domain_name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._workload_domain_name

    @workload_domain_name.setter
    def workload_domain_name(self, workload_domain_name):
        """Sets the workload_domain_name of this ApiCloudaccountsvcfBody.

        Name of the workload domain to add as VCF cloud account.  # noqa: E501

        :param workload_domain_name: The workload_domain_name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if workload_domain_name is None:
            raise ValueError("Invalid value for `workload_domain_name`, must not be `None`")  # noqa: E501

        self._workload_domain_name = workload_domain_name

    @property
    def vcenter_host_name(self):
        """Gets the vcenter_host_name of this ApiCloudaccountsvcfBody.  # noqa: E501

        Host name for the vSphere from the specified workload domain.  # noqa: E501

        :return: The vcenter_host_name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._vcenter_host_name

    @vcenter_host_name.setter
    def vcenter_host_name(self, vcenter_host_name):
        """Sets the vcenter_host_name of this ApiCloudaccountsvcfBody.

        Host name for the vSphere from the specified workload domain.  # noqa: E501

        :param vcenter_host_name: The vcenter_host_name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if vcenter_host_name is None:
            raise ValueError("Invalid value for `vcenter_host_name`, must not be `None`")  # noqa: E501

        self._vcenter_host_name = vcenter_host_name

    @property
    def vcenter_username(self):
        """Gets the vcenter_username of this ApiCloudaccountsvcfBody.  # noqa: E501

        vCenter user name for the specified workload domain.The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials.  # noqa: E501

        :return: The vcenter_username of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._vcenter_username

    @vcenter_username.setter
    def vcenter_username(self, vcenter_username):
        """Sets the vcenter_username of this ApiCloudaccountsvcfBody.

        vCenter user name for the specified workload domain.The specified user requires CloudAdmin credentials. The user does not require CloudGlobalAdmin credentials.  # noqa: E501

        :param vcenter_username: The vcenter_username of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if vcenter_username is None:
            raise ValueError("Invalid value for `vcenter_username`, must not be `None`")  # noqa: E501

        self._vcenter_username = vcenter_username

    @property
    def vcenter_password(self):
        """Gets the vcenter_password of this ApiCloudaccountsvcfBody.  # noqa: E501

        Password for the user used to authenticate with the vCenter in VCF cloud account  # noqa: E501

        :return: The vcenter_password of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._vcenter_password

    @vcenter_password.setter
    def vcenter_password(self, vcenter_password):
        """Sets the vcenter_password of this ApiCloudaccountsvcfBody.

        Password for the user used to authenticate with the vCenter in VCF cloud account  # noqa: E501

        :param vcenter_password: The vcenter_password of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if vcenter_password is None:
            raise ValueError("Invalid value for `vcenter_password`, must not be `None`")  # noqa: E501

        self._vcenter_password = vcenter_password

    @property
    def create_default_zones(self):
        """Gets the create_default_zones of this ApiCloudaccountsvcfBody.  # noqa: E501

        Create default cloud zones for the enabled regions.  # noqa: E501

        :return: The create_default_zones of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: bool
        """
        return self._create_default_zones

    @create_default_zones.setter
    def create_default_zones(self, create_default_zones):
        """Sets the create_default_zones of this ApiCloudaccountsvcfBody.

        Create default cloud zones for the enabled regions.  # noqa: E501

        :param create_default_zones: The create_default_zones of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: bool
        """

        self._create_default_zones = create_default_zones

    @property
    def nsx_host_name(self):
        """Gets the nsx_host_name of this ApiCloudaccountsvcfBody.  # noqa: E501

        Host name for the NSX endpoint from the specified workload domain.  # noqa: E501

        :return: The nsx_host_name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._nsx_host_name

    @nsx_host_name.setter
    def nsx_host_name(self, nsx_host_name):
        """Sets the nsx_host_name of this ApiCloudaccountsvcfBody.

        Host name for the NSX endpoint from the specified workload domain.  # noqa: E501

        :param nsx_host_name: The nsx_host_name of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if nsx_host_name is None:
            raise ValueError("Invalid value for `nsx_host_name`, must not be `None`")  # noqa: E501

        self._nsx_host_name = nsx_host_name

    @property
    def nsx_username(self):
        """Gets the nsx_username of this ApiCloudaccountsvcfBody.  # noqa: E501

        User name for the NSX manager in the specified workload domain.  # noqa: E501

        :return: The nsx_username of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._nsx_username

    @nsx_username.setter
    def nsx_username(self, nsx_username):
        """Sets the nsx_username of this ApiCloudaccountsvcfBody.

        User name for the NSX manager in the specified workload domain.  # noqa: E501

        :param nsx_username: The nsx_username of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if nsx_username is None:
            raise ValueError("Invalid value for `nsx_username`, must not be `None`")  # noqa: E501

        self._nsx_username = nsx_username

    @property
    def nsx_password(self):
        """Gets the nsx_password of this ApiCloudaccountsvcfBody.  # noqa: E501

        Password for the user used to authenticate with the NSX-T manager in VCF cloud account  # noqa: E501

        :return: The nsx_password of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._nsx_password

    @nsx_password.setter
    def nsx_password(self, nsx_password):
        """Sets the nsx_password of this ApiCloudaccountsvcfBody.

        Password for the user used to authenticate with the NSX-T manager in VCF cloud account  # noqa: E501

        :param nsx_password: The nsx_password of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """
        if nsx_password is None:
            raise ValueError("Invalid value for `nsx_password`, must not be `None`")  # noqa: E501

        self._nsx_password = nsx_password

    @property
    def tags(self):
        """Gets the tags of this ApiCloudaccountsvcfBody.  # noqa: E501

        A set of tag keys and optional values to set on the Cloud Account.Cloud account capability tags may enable different features.   # noqa: E501

        :return: The tags of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this ApiCloudaccountsvcfBody.

        A set of tag keys and optional values to set on the Cloud Account.Cloud account capability tags may enable different features.   # noqa: E501

        :param tags: The tags of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def vcenter_certificate(self):
        """Gets the vcenter_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501

        vCenter Certificate  # noqa: E501

        :return: The vcenter_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._vcenter_certificate

    @vcenter_certificate.setter
    def vcenter_certificate(self, vcenter_certificate):
        """Sets the vcenter_certificate of this ApiCloudaccountsvcfBody.

        vCenter Certificate  # noqa: E501

        :param vcenter_certificate: The vcenter_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """

        self._vcenter_certificate = vcenter_certificate

    @property
    def nsx_certificate(self):
        """Gets the nsx_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501

        NSX Certificate  # noqa: E501

        :return: The nsx_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._nsx_certificate

    @nsx_certificate.setter
    def nsx_certificate(self, nsx_certificate):
        """Sets the nsx_certificate of this ApiCloudaccountsvcfBody.

        NSX Certificate  # noqa: E501

        :param nsx_certificate: The nsx_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """

        self._nsx_certificate = nsx_certificate

    @property
    def accept_self_signed_certificate(self):
        """Gets the accept_self_signed_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501

        Accept self signed certificate when connecting to vSphere and NSX-T  # noqa: E501

        :return: The accept_self_signed_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: bool
        """
        return self._accept_self_signed_certificate

    @accept_self_signed_certificate.setter
    def accept_self_signed_certificate(self, accept_self_signed_certificate):
        """Sets the accept_self_signed_certificate of this ApiCloudaccountsvcfBody.

        Accept self signed certificate when connecting to vSphere and NSX-T  # noqa: E501

        :param accept_self_signed_certificate: The accept_self_signed_certificate of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: bool
        """

        self._accept_self_signed_certificate = accept_self_signed_certificate

    @property
    def dc_id(self):
        """Gets the dc_id of this ApiCloudaccountsvcfBody.  # noqa: E501

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Note: Data collector endpoints are not available in VMware Aria Automation (on-prem) release.  # noqa: E501

        :return: The dc_id of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: str
        """
        return self._dc_id

    @dc_id.setter
    def dc_id(self, dc_id):
        """Sets the dc_id of this ApiCloudaccountsvcfBody.

        Identifier of a data collector vm deployed in the on premise infrastructure. Refer to the data-collector API to create or list data collectors. Note: Data collector endpoints are not available in VMware Aria Automation (on-prem) release.  # noqa: E501

        :param dc_id: The dc_id of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: str
        """

        self._dc_id = dc_id

    @property
    def regions(self):
        """Gets the regions of this ApiCloudaccountsvcfBody.  # noqa: E501

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.   # noqa: E501

        :return: The regions of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: list[IaasapicloudaccountsvsphereRegions]
        """
        return self._regions

    @regions.setter
    def regions(self, regions):
        """Sets the regions of this ApiCloudaccountsvcfBody.

        A set of regions to enable provisioning on.Refer to /iaas/api/cloud-accounts/region-enumeration.   # noqa: E501

        :param regions: The regions of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: list[IaasapicloudaccountsvsphereRegions]
        """
        if regions is None:
            raise ValueError("Invalid value for `regions`, must not be `None`")  # noqa: E501

        self._regions = regions

    @property
    def certificate_info(self):
        """Gets the certificate_info of this ApiCloudaccountsvcfBody.  # noqa: E501


        :return: The certificate_info of this ApiCloudaccountsvcfBody.  # noqa: E501
        :rtype: IaasapiintegrationsCertificateInfo
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this ApiCloudaccountsvcfBody.


        :param certificate_info: The certificate_info of this ApiCloudaccountsvcfBody.  # noqa: E501
        :type: IaasapiintegrationsCertificateInfo
        """

        self._certificate_info = certificate_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ApiCloudaccountsvcfBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiCloudaccountsvcfBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
